"use strict";
// Original source: <https://raw.githubusercontent.com/hughsk/chrome-location/master/index.js>
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = __importStar(require("fs"));
var os = __importStar(require("os"));
var path = __importStar(require("path"));
var which_1 = __importDefault(require("which"));
var osx = process.platform === 'darwin';
var win = process.platform === 'win32';
var other = !osx && !win;
function getChromeLocation() {
    var e_1, _a;
    if (other) {
        try {
            return which_1.default.sync('google-chrome');
        }
        catch (e) {
            return null;
        }
    }
    else if (osx) {
        var regPath = '/Applications/Google Chrome.app/Contents/MacOS/Google Chrome';
        var altPath = path.join(os.homedir(), regPath.slice(1));
        return fs.existsSync(regPath)
            ? regPath
            : altPath;
    }
    else {
        var suffix = '\\Google\\Chrome\\Application\\chrome.exe';
        var prefixes = [
            process.env.LOCALAPPDATA,
            process.env.PROGRAMFILES,
            process.env['PROGRAMFILES(X86)']
        ];
        try {
            for (var prefixes_1 = __values(prefixes), prefixes_1_1 = prefixes_1.next(); !prefixes_1_1.done; prefixes_1_1 = prefixes_1.next()) {
                var prefix = prefixes_1_1.value;
                var exe = prefix + suffix;
                if (fs.existsSync(exe)) {
                    return exe;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (prefixes_1_1 && !prefixes_1_1.done && (_a = prefixes_1.return)) _a.call(prefixes_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
    }
    return null;
}
exports.getChromeLocation = getChromeLocation;
